EDIT - task #6745
feature request # 7431 (New): [MASTER] remaining E4 migration issues

Investigate how e4 model changes affect the cached application model in existing Taxeditor
installation

06/21/2017 07:22 AM - Patrick Plitzner

Status: New Start date:

Priority: Highest Due date:

Assignee: Katja Luther % Done: 0%
Category: taxeditor Estimated time: 0:00 hour
Target version: Reviewed Next Major Release

Severity: normal

Description

The application model of the Taxeditor is stored in {home}/.cdmLibrary/.metadata/.plugins/org.eclipse.e4.workbench/workbench.xmi.
This stores all parts, menu items, commands, etc.

While we are still migrating from e3 to e4 and make a lot of changes to the model there could be situation when after installing a new
taxeditor (for developers: after git pull) new GUI objects do not show up because of the existing application model cache. Deleting
the workbench.xmi file solves this problem (developers can also add -clearPersistedState to the program arguments in the launch
configuration of the taxeditor.

We could think about about delivering an extra a batch file that starts the editor with the -clearPersistedState parameter in order to
once reset the application model. Afterwards the editor could be started normally. Having this parameter set for every launch would
always lead to a fresh application model i.e. none of the layout of the windows are opened editors would be restored.

We should look at the parameter apply in the org.eclipse.e4.workbench.model extension point which defines when a model fragment
should be applied to the cached one.

This ticket may also include restore functionality of name editors (#7071)

a lot of eclipse initialization and lifecycle management is defined in plugin.xml of taxeditor.application

= Extensions O~%~¢®
All Extensions 12 = Extension Element Details
Define extensions for this plug-in in the Following section. Set the properties of 'property' Required fields are denoted by '*'.

type filter text a name*: | modelResourceHandler

b <=org.eclipse.core.runtime.applications Add... value*: | bundleclass://eu.etaxonomy.taxeditor.application/eu.etaxonc

b <=org.eclipse.ui.perspectives
b o=org.eclipse.ui.activities
w 2=prg.eclipse.core.runtime.products

Remove

w ¥ EDIT Taxonomic Editor (product)
%] appName (property) Up
|¥| aboutlmage (property)
|¥| aboutText (property)
|%| windowlmages (property)
%] startupForegroundColor (property)
%] startupMessageRect (property)

Down

|¥] startupProgressRect (property)
«| lifeCycleURI (property)

|¥| preferenceCustomization (property)
w o=prg.eclipse.ui.actionSets
Related issues:
https://dev.e-taxonomy.eu/redmine/issues/7071

Related to EDIT - task #6839: remove old workbench.xmi from .cdmlibrary Rejected

Related to EDIT - feature request #7071: Reenable restore functionality New
Related to EDIT - feature request #7007: Migrate IMemento functionality Rejected
Related to EDIT - bug #7997: Some editor windows do not open at the expected ... New

Associated revisions

Revision 1818a5f4 - 07/06/2017 11:47 AM - Patrick Plitzner
fix #6776 ref #6745 Parts with tag "nonRestore" will not be persisted

¢ they will be removed from the application model before it is saved

Revision 0cf9635f - 07/06/2017 02:55 PM - Patrick Plitzner
fix #6776 ref #6745 Parts with tag "nonRestore" will not be persisted
e they will be removed from the application model before it is saved
Revision 8f1f3fe - 07/10/2017 10:18 AM - Patrick Plitzner
ref #6745 Change save location of workbench.xmi
® Register own copy of ResourceHandler to handle loading and storing of the application model

Revision 8c8d24e5 - 07/10/2017 01:55 PM - Patrick Plitzner

ref #6745 Change location of workbench.xmi to {install}/configuration

History

#1 - 06/21/2017 07:36 AM - Patrick Plitzner

- Tags set to eclipse4

#2 - 06/21/2017 10:20 AM - Andreas Miiller

Ja, das ist ein wichtiges Thema. Insbesondere wenn man nightly haufig neuinstalliert, bekommt man beim ersten mal immer Probleme, weil er
irgendwas 6ffnen will was irgendwo wohl mal gedffnet war, obwohl ich in der Zwischenzeit der Editor schon sehr haufig mit anderem Layout
geschlossen habe.

Ich habe das noch nicht systematisch untersucht, aber sollten wir machen.

#3 - 06/29/2017 10:38 PM - Patrick Plitzner

- Subject changed from Investigate how e4 model changes affect the cached application model in exisiting Taxeditor installation to Investigate how e4
model changes affect the cached application model in existing Taxeditor installation

#4 - 07/04/2017 01:43 PM - Andreas Miiller

This is a general problem when working with >1 installations of the editor. We should try to store instance specific xmi files

#5 - 07/06/2017 04:02 PM - Patrick Plitzner

This article might help. Seems like you can programmatically store and load the application model.
http://www.vogella.com/tutorials/Eclipse4ModelPersistence/article.html

#6 - 07/31/2017 07:40 PM - Andreas Miuller

- Related to task #6839: remove old workbench.xmi from .cdmlibrary added

#7 - 09/15/2017 12:30 PM - Patrick Plitzner

After implementing #6847 the launch flag -clearPersistedState does not seem to work anymore. During development you have to manually delete the
workbench.xmi in {workspace}/.metadata/.plugins/org.eclipse.pde.core/.bundle_pool/configuration

Maybe we can implement a switch for dev and release
#8 - 10/25/2017 02:37 PM - Patrick Plitzner
Andreas:

"[lm Editor] der noch keine Verbindung zu einer DB hat, wird versucht, einen Nameeditor zu 6ffnen. Das scheint mir nicht sinnvoll. Es sollte erst nach
o6ffnen der Verbindung passieren.

Wenn ich dann in den ausgegrauten Nameeditor klicke, bekomme ich zudem folgende NPE:
http://www.vogella.com/tutorials/Eclipse4ModelPersistence/article.html
https://dev.e-taxonomy.eu/redmine/issues/6847

Ich habe das jetzt nochmal beobachtet. Es passiert immer, wenn man mehrere TaxEditor Instanzen parallel auf hat. Dann Gbernimmt er die
Information von der bereits gedffneten Instanz. Da miissen wir uns noch was ausdenken."
swt.SWT.error (SWT. java:4533)

swt.SWT.error (SWT. java:4448)
swt.widgets.Synchronizer.runAsyncMessages (Synchronizer. java:185)
swt.widgets.Display.runAsyncMessages (Display.java:4211)
swt.widgets.Display.readAndDispatch (Display.java:3827)

ed.ui.internal.workbench.swt.PartRenderingEngine$4.run (PartRenderingEngine. java

core.databinding.observable.Realm.runWithDefault (Realm. java:336)

e4.ui.internal.workbench.swt.PartRenderingEngine.run (PartRenderingEngine. java:1l

ed.ui.internal.workbench.E4Workbench.createAndRunUI (E4Workbench. java:150)
uil.internal.Workbench$5.run (Workbench. java:693)
core.databinding.observable.Realm.runWithDefault (Realm. java:336)
core.runtime.internal.adaptor.EclipseAppLauncher.runApplication (EclipseAppLaunc

core.runtime.internal.adaptor.EclipseAppLauncher.start (EclipseAppLauncher. java:

core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:388)

core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:243)

.NativeMethodAccessorImpl.invokeO (Native Method)

NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)
di.InjectionException: java.lang.NullPointerException
swt.widgets.RunnableLock.run (RunnableLock. java:35)
ed.core.internal.di.MethodRequestor.execute (MethodRequestor. java:55)

#9 - 05/16/2018 02:15 PM - Patrick Plitzner

- Related to feature request #7071: Reenable restore functionality added

#10 - 05/16/2018 02:15 PM - Patrick Plitzner

- Related to feature request #7007: Migrate IMemento functionality added

#11 - 05/18/2018 01:43 PM - Andreas Miiller
- Parent task set to #6565

#12 - 05/18/2018 02:06 PM - Andreas Miiller
- Parent task changed from #6565 to #7431

#13 - 05/18/2018 02:25 PM - Andreas Miiller

- Description updated

#14 - 08/22/2018 11:26 AM - Andreas Muller

- Target version changed from Unassigned CDM tickets to Release 5.4

#15 - 10/19/2018 03:05 PM - Patrick Plitzner

- Target version changed from Release 5.4 to Release 5.5

#16 - 10/23/2018 10:36 AM - Patrick Plitzner

- Target version changed from Release 5.5 to Release 5.6

#17 - 01/17/2019 08:20 AM - Patrick Plitzner

- Related to bug #7997: Some editor windows do not open at the expected location added

#18 - 02/20/2019 03:42 PM - Patrick Plitzner

- Priority changed from New to Highest

#19 - 02/20/2019 03:47 PM - Patrick Plitzner

- Target version changed from Release 5.6 to Reviewed Next Major Release

#20 - 11/18/2019 01:14 PM - Andreas Miiller
- Tags changed from eclipse4 to eclipse4, pp_uebergabe

#21 - 11/18/2019 01:15 PM - Andreas Miiller

- Assignee changed from Patrick Plitzner to Katja Luther

#22 - 12/06/2019 12:16 PM - Patrick Plitzner
- Tags changed from eclipse4, pp_uebergabe to eclipse4
- File picture298-1.png added

- Description updated

Files
